






#ifndef __IMAGER_FUNCTIONS2_H__
#define __IMAGER_FUNCTIONS2_H__

int spl_cache_z;
int spl_cache_uid;
int spl_cache_deg;
long rndreg;


int isqrt (long x);

double SDEV (double Sx, double Sxx, int N);

void cub_coeff (double *a, double x, unsigned char type);

float windowfn (float buf, float x, float y, int wndtype);

void combsort_f (float *array, int *links, int size);
void combsort_i (int *array, int *links, int size);


fitresult loglogfit (double* x, double* y, int st, int en);
fitresult lsqfit (double* xdata, double* ydata, int st, int en);

float nr_rand2 ();			/* Random numbers from 0 to 1, box distribution */
float gauss_rnd ();			/* Gaussian-distribution random numbers, zero mean, SD=1 */
float eran1 ();				/* Exponentially-distributed, positive random numbers of unit mean */
float pnoise (int x, int y, int level);	/* 2D deterministic noise generator for Perlin noise */
float perlin_noise (float x, float y, float H, int octaves);		
							/* Perlin noise synthesizer, H is the persistence, 0<H<1 */

void create_fbm (float* timeseries, float sd, float h, int numpoints, char make_fbm);
							/* FBM random noise by successive random additions */
void create_fbm_spectral (float *timeseries, float sd, float beta, int numpoints, char make_fbm);
							/* FBM or FBN time series by spectral synthesis */
void create_2d_fbm_spectral (image_type *img, float beta, int numpoints);
							/* FBM 2D data by spectral synthesis */


/* Natural cubic spline interplation */

typedef struct
{
	int npoints;
	float *coeff_a;
	float *coeff_b;
	float *coeff_c;
	float *coeff_d;
}
spline_block;

void spline_new (spline_block *spl, int numpts, float *v);
float spline_get (spline_block *spl, int segment, float t);
void spline_free (spline_block *spl);


/* Matrix operations */

MFLOAT det2x2 (MFLOAT *A);

MFLOAT pythag (MFLOAT a, MFLOAT b);

int matsolv (MFLOAT *A, MFLOAT *B, int n);
void mat_transpose (MFLOAT *A, int n);
void matmult (MFLOAT* A, MFLOAT* V, int n);
void matmulnm (MFLOAT *R, MFLOAT* A, MFLOAT* V, int n, int m);
void householder_reduction (MFLOAT* A, int n, MFLOAT* D, MFLOAT* E);
void eigen_ql (MFLOAT* A, int n, MFLOAT* D, MFLOAT* E);

void testmatrix ();




#endif
